(ns com.oly.static-sites.do-blog.theme)

(defn link-handler [v d]
  (if (-> v second :img)
    (conj [:img] (-> (dissoc (clojure.set/rename-keys (second v) {:href :src}) :img)
                     (update :src #(clojure.string/replace % #"\.\./" "")) )
          )
    (conj [:a] (second v))))


(def tachyon-theme
  {:TITLE :header.f2.fw6.f2-ns.lh-title.mt0.mb2
   ;:DESCRIPTION :p
   :HEADER1 :h1.f3.fw6.f3-ns.lh-title.mt0.mb2
   :HEADER2 :h2.f3.fw6.f3-ns.lh-title.mt0.mb2
   :HEADER3 :h3
   :HEADER4 :h4
   :HEADER5 :h5
   :TODO :span
   :VERBATIM :code
   :CODE :code

   :MAIN :main

   :THUMBNAIL nil
   :DESCRIPTION :meta ;(fn [v] [:span {:name (str v)} ])
   :CATEGORY :meta ;(fn [v] [:span {:name (str v)} ])
   :SLUG :meta ;(fn [v] [:span {:name (str v)} ])
   :DATE :meta ;(fn [v] [:span {:name (str v)} ])
   :FILETAGS (fn [v] [:meta {:name "keywords" :content (str v)}])
   :NAME :meta ;(fn [v] [:span {:name (str v)} ])
   :HTML_DOCTYPE :meta

   :TABLE :table.collapse.ba.br2.b--black-10.pv2.ph3
   :TBODY :tbody
   :THEAD :thead
   :TR :tr.striped--light-gray
   :TD :td.pv2.ph3

   ;;TODO this is a src attrib probably worth handling this differently
   ;;perhaps allow custom functions instead of a simple replace
   :LANGUAGE :class
   :SRC :pre.bg-near-black.silver.pa2.hljs.roboto.overflow-auto.klipse.f6
   :RESULTS :pre.bg-near-black.silver.pa2.hljs.roboto.overflow-auto
   :EXAMPLE :pre.bg-near-black.silver.pa2.hljs.roboto.overflow-auto
   :COMMENT nil
   :CAPTION :span
   :I :i
   :U :u
   :B :b
   :LINK link-handler
   :IMG :img
   ;; probably remove these 2
   :A :a
   :P :p
   :BR :br
   :LINE :p.f5.f4-ns.lh-copy.mt0
   :BULLETS-ORDERED :ol
   :BULLETS :ul
   :BULLET :li
   })
